// TK80Doc.cpp : Implementierung der Klasse CTK80Doc
//

#include "stdafx.h"
#include "TK80.h"

#include "TK80Doc.h"
#include <mmsystem.h>


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//##ModelId=43AD0C1D020D
DWORD WINAPI CTK80Doc::RunCPU(void * pDoc)
{	
	CTK80Doc *Doc = (CTK80Doc*)pDoc;
	if(!pDoc)
		return -1;
	Doc->m_cpustatus = true;
	Doc->run();
	DWORD res = 
	Doc->m_cpustatus = false;
	return res;
}

unsigned char& CTK80Doc::operator [] ( WORD Addr)
{
	static unsigned char hole = 0xff;
	Addr &=0x83FF;
	// ROM
	if( Addr < 0x300)
		return tk_80_ROM[Addr];
	// EEPROM
	if( Addr < 0x400)
		return tk_80_EEPROM[Addr-0x300];
	// Blank Area
	if( Addr < 0x8000)
		return hole;
	// RAM
	return m_mem[Addr&0xFFF];
	return hole;
}

//##ModelId=43AD0C1D01F5
void CTK80Doc::WrZ80( WORD Addr, byte Value)
{
	Addr &=0x83FF;

	// ROM
	if( Addr < 0x300)
		return;
	// EEPROM
	if( Addr < 0x400)
		return;
	// Blank Area
	if( Addr < 0x8000)
		return;

	// RAM
	char o = m_mem[Addr&0xFFF];
	m_mem[Addr&0xFFF]=Value;
	if(o != Value && m_Dump.IsWindowEnabled())
		m_Dump.OnMemChanged(Addr);

	return;
};

//##ModelId=43AD0C1D01F9
byte CTK80Doc::RdZ80( WORD Addr, bool OpCode) const
{
	return const_cast<CTK80Doc&> (*this)[Addr]; 
};


#define Z8255_PORTA 0x00F8
#define Z8255_PORTB 0x00F9
#define Z8255_PORTC 0x00FA
#define Z8255_CONTROL 0x00FB

//##ModelId=43AD0C1D01FD
void CTK80Doc::OutZ80( WORD Port, byte Value)
{
	switch(Port)
	{
	case Z8255_PORTA:
		break;
	case Z8255_PORTB:
		break;
	case Z8255_PORTC:
		m_keyline = Value & 0x70;
		if(!(Value & 0x80) && (!(Value & 0x01) || m_tapebit))
		{
			m_tapebyte |= (Value & 0x01) << m_tapebit++;
			m_tapebit %=10;
			
			if(!m_tapebit)
			{
				m_Tape.AddByte((m_tapebyte>>1) & 0xff);
				m_tapebyte=0;
			}
		}
		break;
	case Z8255_CONTROL:

		break;
	default:
		break;
	}
};

//##ModelId=43AD0C1D0201
byte CTK80Doc::InZ80(WORD Port) const
{
	byte res;

	switch(Port)
	{
	case Z8255_PORTA:
		{
			int idx = ((~m_keyline & 0x70) >> 4) & 0x7; // 0 1 2 4
			if( idx == 1 || idx == 2 || idx == 4)
				res = m_keymap[idx>>1];
		}
		break;
	case Z8255_PORTB:
	//	res = m_Tape.GetBit(0xfe);
		break;
	case Z8255_PORTC:
		;
		break;
	case Z8255_CONTROL:
		;
		break;
	default:
		res = 0xff;
		break;
	}
	return res;
};
	



/////////////////////////////////////////////////////////////////////////////
// CTK80Doc

IMPLEMENT_DYNCREATE(CTK80Doc, CDocument)

BEGIN_MESSAGE_MAP(CTK80Doc, CDocument)
	//{{AFX_MSG_MAP(CTK80Doc)
	ON_COMMAND(ID_MEMDUMP, OnMemdump)
	ON_UPDATE_COMMAND_UI(ID_MEMDUMP, OnUpdateMemdump)
	ON_COMMAND(ID_BUTTOMHLT, OnButtomhlt)
	ON_UPDATE_COMMAND_UI(ID_BUTTOMHLT, OnUpdateButtomhlt)
	ON_COMMAND(IDM_TAPE, OnTape)
	ON_UPDATE_COMMAND_UI(IDM_TAPE, OnUpdateTape)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTK80Doc Konstruktion/Destruktion

//##ModelId=43AD0C1D01E0
CTK80Doc::CTK80Doc()
:m_keyline(0)
,m_Dump(AfxGetApp()->m_pMainWnd)
,m_Tape(AfxGetApp()->m_pMainWnd)
,m_cpustatus(false)
,m_tapebyte(0)
,m_tapebit(0)
{
	memset(m_mem,0,sizeof(m_mem));
	memset(tk_80_EEPROM,0,sizeof(tk_80_EEPROM));
	m_keymap[0] = m_keymap[1] = m_keymap[2] = 0xff;
	m_cpuThread = CreateThread(
		0,			    // pointer to security attributes
		0,              // initial thread stack size
		&RunCPU,    // pointer to thread function
		this,           // argument for new thread
		CREATE_SUSPENDED,  // creation flagsTHREAD_PRIORITY_LOWEST
		&m_cpuThreadid  // pointer to receive thread ID
		);
	SetThreadPriority( m_cpuThread, THREAD_PRIORITY_LOWEST);
	m_Tape.Create(CTapefile::IDD);
	m_Tape.EnableWindow(false);
	m_Dump.Create(CMemDump::IDD);
	m_Dump.EnableWindow(false);
}

//##ModelId=43AD0C1D01EC
CTK80Doc::~CTK80Doc()
{

}


//##ModelId=43AD0C1D01E1
BOOL CTK80Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// ZU ERLEDIGEN: Hier Code zur Reinitialisierung einfgen
	// (SDI-Dokumente verwenden dieses Dokument)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CTK80Doc Serialisierung

//##ModelId=43AD0C1D01E3
void CTK80Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// ZU ERLEDIGEN: Hier Code zum Speichern einfgen
	}
	else
	{
		// ZU ERLEDIGEN: Hier Code zum Laden einfgen
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTK80Doc Diagnose

#ifdef _DEBUG
//##ModelId=43AD0C1D01EE
void CTK80Doc::AssertValid() const
{
	CDocument::AssertValid();
}

//##ModelId=43AD0C1D01F0
void CTK80Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTK80Doc Befehle


//##ModelId=43AD0C1D01EA
void CTK80Doc::KeyPress(keycode key)
{
	m_keymap[0] = m_keymap[1] = m_keymap[2] = 0xff;

	switch(toupper(key))
	{
	case K_0: m_keymap[0] = 0xfe ;
		break;
	case K_1: m_keymap[0] = 0xfd ;
		break;
	case K_2: m_keymap[0] = 0xfb ;
		break;
	case K_3: m_keymap[0] = 0xf7 ;
		break;
	case K_4: m_keymap[0] = 0xef ;
		break;
	case K_5: m_keymap[0] = 0xdf ;
		break;
	case K_6: m_keymap[0] = 0xbf ;
		break;
	case K_7: m_keymap[0] = 0x7f ;
		break;
	case K_8: m_keymap[1] = 0xfe ;
		break;
	case K_9: m_keymap[1] = 0xfd ;
		break;
	case K_A: m_keymap[1] = 0xfb ;
		break;
	case K_B: m_keymap[1] = 0xf7 ;
		break;
	case K_C: m_keymap[1] = 0xef ;
		break;
	case K_D: m_keymap[1] = 0xdf ;
		break;
	case K_E: m_keymap[1] = 0xbf ;
		break;
	case K_F: m_keymap[1] = 0x7f ;
		break;
	case K_LOAD: m_keymap[2] = 0x7f ;
		break;
	case K_STORE: m_keymap[2] = 0xbf ;
		break;
	case K_W: m_keymap[2] = 0xdf ;
		break;
	case K_RPUS: m_keymap[2] = 0xef ;
		break;
	case K_RMIN: m_keymap[2] = 0xf7 ;
		break;
	case K_ADRSET: m_keymap[2] = 0xfb ;
		break;
	case K_RET: m_keymap[2] = 0xfd ;
		break;
	case K_RUN: m_keymap[2] = 0xfe ;
		break;
	case K_RESET: reset();
	default:
		m_keymap[0] = m_keymap[1] = m_keymap[2] = 0xff;
		break;
	}
}

//##ModelId=43AD0C1D0235
void CTK80Doc::OnMemdump() 
{
		CString label;
		m_Dump.SetDoc(this);
        m_Dump.ShowWindow(SW_SHOWNORMAL);
		m_Dump.EnableWindow(true);

		unsigned i,ii;
		for(i = 0; i < 0x30; i++)
		{
			label.Format("%04X.ROM",i<<4);
			ii = m_Dump.m_memdump.AddString(label);
			m_Dump.m_memdump.SetItemData( ii, 0xFFAAAA);
		}
		for(i = 0x30; i < 0x40; i++)
		{
			label.Format("%04X.EEP",i<<4);
			ii = m_Dump.m_memdump.AddString(label);
			m_Dump.m_memdump.SetItemData( ii, 0xAAFFAA);
		}
		for(i = 0x800; i < 0x840; i++)
		{
			label.Format("%04X.RAM",i<<4);
			ii = m_Dump.m_memdump.AddString(label);
			m_Dump.m_memdump.SetItemData( ii, 0xAAAAFF);
		}
}

//##ModelId=43AD0C1D0237
void CTK80Doc::OnUpdateMemdump(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !m_Dump.IsWindowEnabled());
}

//##ModelId=43AD0C1D01E6
void CTK80Doc::ClearDumpWindow()
{
//	m_dumpActive = false;
}

//##ModelId=43AD0C1D023C
void CTK80Doc::OnButtomhlt() 
{
	if( m_cpustatus)
		SuspendThread(m_cpuThread);
	else
		ResumeThread(m_cpuThread);
	m_cpustatus = !m_cpustatus;
	UpdateAllViews(0);
}

//##ModelId=43AD0C1D023E
void CTK80Doc::OnUpdateButtomhlt(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_cpustatus);
}


//##ModelId=43AD0C1D0244
void CTK80Doc::OnTape() 
{
	m_Tape.ShowWindow(SW_SHOWNORMAL);
	m_Tape.EnableWindow(true);

}

//##ModelId=43AD0C1D0246
void CTK80Doc::OnUpdateTape(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable( !m_Tape.IsWindowEnabled());
}
