// TK80Doc.h : Schnittstelle der Klasse CTK80Doc
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TK80DOC_H__95B6504C_DAC3_4AEF_BE4E_31FD42C8794D__INCLUDED_)
#define AFX_TK80DOC_H__95B6504C_DAC3_4AEF_BE4E_31FD42C8794D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "zilog.h"
#include <iostream>
#include "MemDump.h"	// Hinzugefgt von der Klassenansicht
#include "Tapefile.h"
using namespace std;
extern unsigned char tk_80_EEPROM[0x100];
extern unsigned char tk_80_ROM[0x300];

//##ModelId=43AD0C1D01AE
typedef enum {
		K_NOKEY	= 0,
	    K_RET	= 'X',
		K_RUN	= 'R',
		K_STORE = 'S',
		K_LOAD  = 'L',
		K_RESET = 'Q',
		K_C		= 'C',
		K_D		= 'D',
		K_E		= 'E',
		K_F		= 'F',
		K_ADRSET= '@',
		K_8		= '8',
		K_9		= '9',
		K_A		= 'A',
		K_B		= 'B',
		K_RPUS	= '+',
		K_4		= '4',
		K_5		= '5',
		K_6		= '6',
		K_7		= '7',
		K_RMIN	= '-',
		K_0		= '0',
		K_1		= '1',
		K_2		= '2',
		K_3		= '3',
		K_W		= 'W'
} keycode;

//##ModelId=43AD0C1D01D6
class CTK80Doc : public CDocument, public z80
{
protected: // Nur aus Serialisierung erzeugen
	//##ModelId=43AD0C1D01E0
	CTK80Doc();
	DECLARE_DYNCREATE(CTK80Doc)

// Attribute
public:

// Operationen
public:

// berladungen
	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CTK80Doc)
	public:
	//##ModelId=43AD0C1D01E1
	virtual BOOL OnNewDocument();
	//##ModelId=43AD0C1D01E3
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementierung
public:
	//##ModelId=43AD0C1D01E6
	void ClearDumpWindow();
	//##ModelId=43AD0C1D01EA
	void KeyPress( keycode key);
	//##ModelId=43AD0C1D01EC
	virtual ~CTK80Doc();
#ifdef _DEBUG
	//##ModelId=43AD0C1D01EE
	virtual void AssertValid() const;
	//##ModelId=43AD0C1D01F0
	virtual void Dump(CDumpContext& dc) const;
#endif
	/** ResetZ80() ***********************************************/
	/** This function can be used to reset the s before **/
	/** starting execution with RunZ80(). It sets s to  **/
	/** their initial values.                                   **/
	/*************************************************************/
	//##ModelId=43AD0C1D01F3
//	void virtual ResetZ80(){ m_Tape.Reset();m_Dump.Reset();CZ80::ResetZ80();} ;

	//##ModelId=43AD0C1D01F5
	virtual void WrZ80( WORD Addr, byte Value);
	//##ModelId=43AD0C1D01F9
	virtual byte RdZ80( WORD Addr, bool OpCode = false) const;
	
	/** InZ80()/OutZ80() *****************************************/
	/** Z80 emulation calls these functions to read/write from  **/
	/** I/O ports. There can be 65536 I/O ports, but only first **/
	/** 256 are usually used                                    **/
	/************************************ TO BE WRITTEN BY USER **/
	//##ModelId=43AD0C1D01FD
	virtual void OutZ80( WORD Port, byte Value);
	//##ModelId=43AD0C1D0201
	virtual byte InZ80( WORD Port)const;
	
	/** PatchZ80() ***********************************************/
	/** Z80 emulation calls this function when it encounters a  **/
	/** special patch command (ED FE) provided for user needs.  **/
	/** For example, it can be called to emulate BIOS calls,    **/
	/** such as disk and tape access. Replace it with an empty  **/
	/** macro for no patching.                                  **/
	/************************************ TO BE WRITTEN BY USER **/
	//##ModelId=43AD0C1D0204
	virtual void PatchZ80()const{return;};
	
	/** LoopZ80() ************************************************/
	/** Z80 emulation calls this function periodically to check **/
	/** if the system hardware requires any interrupts. This    **/
	/** function must return an address of the interrupt vector **/
	/** (0x0038, 0x0066, etc.) or INT_NONE for no interrupt.    **/
	/** Return INT_QUIT to exit the emulation loop.             **/
	/************************************ TO BE WRITTEN BY USER **/
	//##ModelId=43AD0C1D0206
	virtual WORD LoopZ80()const
	{
//		Sleep(100);
		return INT_NONE;
	};
	//##ModelId=43AD0C1D020A
	bool CpuOn(void){ return m_cpustatus;};

	virtual BYTE& operator [] (WORD addr);	// Interface to Memory
	virtual BYTE io_in(BYTE adr){ return InZ80(adr);};			// Interface for port input
	virtual void io_out(BYTE adr, BYTE data){ OutZ80(adr,data);};// Interface for Protn output
	virtual BYTE nmiack(void){ return 0;};
	virtual BYTE intrack(int_mode_t mode){ return 0;};
private:
	//##ModelId=43AD0C1D020C
	unsigned char m_mem[0x400];

	//##ModelId=43AD0C1D020D
	static DWORD WINAPI RunCPU(void * pDoc);

protected:
	//##ModelId=43AD0C1D0212
	HANDLE m_cpuThread;
	//##ModelId=43AD0C1D0213
	DWORD  m_cpuThreadid;
	//##ModelId=43AD0C1D0214
	UINT   m_keyline;
	//##ModelId=43AD0C1D0215
	UINT   m_keyrow;
	//##ModelId=43AD0C1D021D
	byte   m_keymap[3];
// Generierte Message-Map-Funktionen
protected:
	//##ModelId=43AD0C1D0222
	unsigned m_tapebyte;
	//##ModelId=43AD0C1D0226
	int m_tapebit;
	//##ModelId=43AD0C1D0228
	CTapefile m_Tape;
	//##ModelId=43AD0C1D022C
	bool m_cpustatus;
	//##ModelId=43AD0C1D0231
	CMemDump m_Dump;
	//{{AFX_MSG(CTK80Doc)
	//##ModelId=43AD0C1D0235
	afx_msg void OnMemdump();
	//##ModelId=43AD0C1D0237
	afx_msg void OnUpdateMemdump(CCmdUI* pCmdUI);
	//##ModelId=43AD0C1D023C
	afx_msg void OnButtomhlt();
	//##ModelId=43AD0C1D023E
	afx_msg void OnUpdateButtomhlt(CCmdUI* pCmdUI);
	//##ModelId=43AD0C1D0244
	afx_msg void OnTape();
	//##ModelId=43AD0C1D0246
	afx_msg void OnUpdateTape(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ fgt unmittelbar vor der vorhergehenden Zeile zustzliche Deklarationen ein.

#endif // !defined(AFX_TK80DOC_H__95B6504C_DAC3_4AEF_BE4E_31FD42C8794D__INCLUDED_)
