// TK80View.cpp : Implementierung der Klasse CTK80View
//

#include "stdafx.h"
#include "TK80.h"

#include "TK80Doc.h"
#include "TK80View.h"
#include <mmsystem.h>
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTK80View

IMPLEMENT_DYNCREATE(CTK80View, CView)

BEGIN_MESSAGE_MAP(CTK80View, CView)
	//{{AFX_MSG_MAP(CTK80View)
	ON_WM_TIMER()
	ON_WM_ERASEBKGND()
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	//}}AFX_MSG_MAP
	// Standard-Druckbefehle
//	ON_COMMAND(ID_BUT, OnCPS)
	ON_UPDATE_COMMAND_UI(ID_INDICATOR_CPU, OnUpdateCPS)
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)

END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTK80View Konstruktion/Destruktion
//##ModelId=43AD0C1D014D
const keycode CTK80View::m_keyset[5][5] = {
	{K_RET,K_RUN,K_STORE,K_LOAD,K_RESET},
	{K_C,K_D,K_E,K_F,K_ADRSET},
	{K_8,K_9,K_A,K_B,K_RPUS},
	{K_4,K_5,K_6,K_7,K_RMIN},
	{K_0,K_1,K_2,K_3,K_W}
};

#define D7X  444
#define D7Y   30

#define D7W  30
#define D7H  77 
#define D7S   4
#define D7T  19


#define KFX   504
#define KFY   185
#define KFW   214
#define KFH   210

#define KX	   38
#define KY     38
#define KXD	    5
#define KYD     5

#define XX(x) ((x)*KX)
#define DX(x) ((x)*KXD)
#define XXX(x) (XX(x)+DX(x))

#define YY(y) ((y)*KY)
#define DY(y) ((y)*KYD)
#define YYY(y) (YY(y)+DY(y))


#define SR(x,y)  { KFX + XXX(x), KFY + YYY(y), KFX + XXX(x) + KX, KFY + YYY(y) + KY}


//##ModelId=43AD0C1D0160
const RECT CTK80View::m_key[5][5] =
{
	{ SR(0,0), SR(0,1), SR(0,2), SR(0,3), SR(0,4) },
	{ SR(1,0), SR(1,1), SR(1,2), SR(1,3), SR(1,4) },
	{ SR(2,0), SR(2,1), SR(2,2), SR(2,3), SR(2,4) },
	{ SR(3,0), SR(3,1), SR(3,2), SR(3,3), SR(3,4) },
	{ SR(4,0), SR(4,1), SR(4,2), SR(4,3), SR(4,4) },
};

#define SY1 297
#define SX1 27
#define SY2 340
#define SX2 27

 
//##ModelId=43AD0C1D0169
const RECT CTK80View::m_switch[2] = {{SX1,SY1,SX1+35,SY1+18},{SX2,SY2,SX2+35,SY2+18}}; 

CTK80View::CTK80View()
:m_timer(0)
,m_r7seg(D7X,D7Y,D7X + (D7Y<<3) + (D7S*6) + D7T,D7H)
,m_over(0,0,0,0)
,m_down(false)
,m_cps(0)
,m_sw1(false)
,m_sw2(false)
{
	m_smap.LoadBitmap(IDB_SWITCH);
	m_bkg.LoadBitmap(IDB_TK80BITMAP);
	BITMAP bpm;
	m_bkg.GetBitmap(&bpm);
	m_csize.cx = bpm.bmWidth;
	m_csize.cy = bpm.bmHeight;	
}

//##ModelId=43AD0C1D0144
CTK80View::~CTK80View()
{
//	if(m_timer)
//		KillTimer(m_timer);
}

//##ModelId=43AD0C1D0132
BOOL CTK80View::PreCreateWindow(CREATESTRUCT& cs)
{
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CTK80View Zeichnen

#define TIMERPER 250 

//##ModelId=43AD0C1D012F
void CTK80View::OnDraw(CDC* pDC)
{
	CTK80Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	CRect r7(m_r7seg.left,m_r7seg.top,m_r7seg.left+D7W,D7H);

	if( !m_timer)
		m_timer = SetTimer(1, TIMERPER, 0);
	
	pDC->SelectObject( GetStockObject(HOLLOW_BRUSH));
	
	if(!m_over.IsRectEmpty())
	{
		if(m_down)
			pDC->InvertRect(m_over);
		else
		{
			CBrush bru(0x5555FF);
			pDC->FrameRect((LPRECT)m_over,&bru);
		}

	}
	if( m_sw1 || m_sw2)
	{
		CDC cdc;
		cdc.CreateCompatibleDC(pDC );
		cdc.SelectObject(m_smap);
		if(m_sw1) pDC->BitBlt(m_switch[0].left,m_switch[0].top,m_switch[0].left,m_switch[0].bottom,&cdc,0,0,SRCCOPY   );
		if(m_sw2) pDC->BitBlt(m_switch[1].left,m_switch[1].top,m_switch[1].left,m_switch[1].bottom,&cdc,0,0,SRCCOPY);

	}

	if( pDoc->CpuOn())
		for(WORD a = 0x83f8; a < 0x8400; a++)
		{
			//pDC->Rectangle(r7);
			Draw7(pDC,r7,pDoc->RdZ80(a));
			r7.OffsetRect( D7W + (a==0x83fb? D7T:D7S),0);
		}
}

/////////////////////////////////////////////////////////////////////////////
// CTK80View Drucken

//##ModelId=43AD0C1D0138
BOOL CTK80View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// Standardvorbereitung
	return DoPreparePrinting(pInfo);
}

//##ModelId=43AD0C1D013B
void CTK80View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Zustzliche Initialisierung vor dem Drucken hier einfgen
}

//##ModelId=43AD0C1D0140
void CTK80View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// ZU ERLEDIGEN: Hier Bereinigungsarbeiten nach dem Drucken einfgen
}

/////////////////////////////////////////////////////////////////////////////
// CTK80View Diagnose

#ifdef _DEBUG
//##ModelId=43AD0C1D0146
void CTK80View::AssertValid() const
{
	CView::AssertValid();
}

//##ModelId=43AD0C1D0148
void CTK80View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

//##ModelId=43AD0C1D012E
CTK80Doc* CTK80View::GetDocument() // Die endgltige (nicht zur Fehlersuche kompilierte) Version ist Inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CTK80Doc)));
	return (CTK80Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTK80View Nachrichten-Handler
//##ModelId=43AD0C1D017E
void CTK80View::Draw7(CDC *pDC, const CRect &_rect, unsigned char code)
{
	int p = 4;//w>>2 | 1;
	CRect rect = _rect;
	rect.DeflateRect(p<<1,p<<1);
	int w = rect.Width();
	int h = rect.Height()>>1;
	
	CPen pon( PS_SOLID , p, 0x5555ff);
	CPen *org = (CPen*) pDC->SelectObject(&pon);
	
	// a
	if( code & 0x01)
	{
		pDC->MoveTo(rect.left+2,rect.top);
		pDC->LineTo(rect.right+2,rect.top);
	}
	// b
	if( code & 0x02)
	{
		pDC->MoveTo(rect.right+2,rect.top);
		pDC->LineTo(rect.right,rect.top+h);
	}
	// c
	if( code & 0x04)
	{	
		pDC->MoveTo(rect.right,rect.top+h);
		pDC->LineTo(rect.right-2,rect.bottom);
	}
	// d
	if( code & 0x08)
	{
		pDC->MoveTo(rect.left-2,rect.bottom);
		pDC->LineTo(rect.right-2,rect.bottom);
	}
	// e
	if( code & 0x10)
	{	
		pDC->MoveTo(rect.left,rect.top+h);
		pDC->LineTo(rect.left-2,rect.bottom);
	}
	// f
	if( code & 0x20)
	{	
		pDC->MoveTo(rect.left+2,rect.top);
		pDC->LineTo(rect.left,rect.top+h);
	}
	// g
	if( code & 0x40)
	{
		pDC->MoveTo(rect.left,rect.top+h);
		pDC->LineTo(rect.right,rect.top+h);
	}
	// dp
	if( code & 0x80)
	{
		pDC->MoveTo(rect.right+3,rect.bottom+3);
		pDC->LineTo(rect.right+2,rect.bottom+3);
	}
	pDC->SelectObject(org);
	
	
}

//##ModelId=43AD0C1D0188
void CTK80View::OnTimer(UINT nIDEvent) 
{
	InvalidateRect(m_r7seg);
	CView::OnTimer(nIDEvent);
}

//##ModelId=43AD0C1D018B
BOOL CTK80View::OnEraseBkgnd(CDC* pDC) 
{
	CDC		cdc;
	cdc.CreateCompatibleDC(pDC);
	cdc.SelectObject(m_bkg);
	pDC->BitBlt(0,0,m_csize.cx,m_csize.cy,&cdc,0,0,SRCCOPY);
	return true;
}

static 	const CRect NOOVER(0,0,0,0);

//##ModelId=43AD0C1D0191
void CTK80View::OnMouseMove(UINT nFlags, CPoint point) 
{

	int x;
	int y;
	keycode c = K_NOKEY;
	for(y=0;y<5;y++)
		for(x=0;x<5;x++)
			if(CRect(m_key[x][y]).PtInRect(point))
			{
				c = (keycode) m_keyset[y][x];
				goto out;
			}
out:
	if(m_over != CRect(m_key[x][y]))
		SetOver(c!=K_NOKEY ? m_key[x][y]:NOOVER);
	CView::OnMouseMove(nFlags, point);
}

//##ModelId=43AD0C1D0195
void CTK80View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int x;
	int y;
	keycode c = K_NOKEY;

	CTK80Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	if(CRect(m_switch[0]).PtInRect(point))
	{
		m_sw1 = m_sw1?false:true;
		InvalidateRect(&m_switch[0]);
		PlaySound (MAKEINTRESOURCE(IDR_SWSOUND), ::AfxGetInstanceHandle(), SND_RESOURCE | SND_ASYNC);
	}
	if(CRect(m_switch[1]).PtInRect(point))
	{
		m_sw2 = m_sw2?false:true;
		InvalidateRect(&m_switch[1]);
		PlaySound (MAKEINTRESOURCE(IDR_SWSOUND), ::AfxGetInstanceHandle(), SND_RESOURCE | SND_ASYNC);
	}

	m_down = true;
	for(y=0;y<5;y++)
		for(x=0;x<5;x++)
			if(CRect(m_key[x][y]).PtInRect(point))
			{
				c = (keycode) m_keyset[y][x];
				goto out;
			}
out:
	SetOver(c!=K_NOKEY ? m_key[x][y]:NOOVER);

	pDoc->KeyPress(c);
	CView::OnLButtonDown(nFlags, point);
}

//##ModelId=43AD0C1D019D
void CTK80View::OnLButtonUp(UINT nFlags, CPoint point) 
{
	int x;
	int y;
	keycode c = K_NOKEY;

	CTK80Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	m_down = false;
	for(y=0;y<5;y++)
		for(x=0;x<5;x++)
			if(CRect(m_key[x][y]).PtInRect(point))
			{
				c = (keycode) m_keyset[y][x];
				goto out;
			}
out:
	SetOver(c!=K_NOKEY ? m_key[x][y]:NOOVER);
	pDoc->KeyPress(K_NOKEY);
	CView::OnLButtonUp(nFlags, point);
}

//##ModelId=43AD0C1D017C
void CTK80View::SetOver(const CRect& rect)
{
//	if( rect != m_over)
	{
		if(! m_over.IsRectEmpty())
			InvalidateRect(m_over);
		m_over = rect;
		if(! m_over.IsRectEmpty())
			InvalidateRect(m_over);
	}
}

//##ModelId=43AD0C1D01A5
void CTK80View::OnUpdateCPS(CCmdUI *pCmdUI)
{
	static long div=0;
	static long cy=0;
	static long is=0;
    static time_t tt = time(0);
	CTK80Doc *pDoc = GetDocument();
//	cy += pDoc->GetTCyclesSec();
//	is += pDoc->GetInstructionsSec();
    div++;

	pCmdUI->Enable(true);

    time_t nt = time(0);
	if( nt > tt)
	{
		tt = nt;
		CString strPage;
		strPage.Format( "%.8Lu / %.8Lu", cy/div, is/div ); 
		pCmdUI->SetText( strPage );
		div = cy = is = 0;
	}
}

