// Tapefile.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "tk80.h"
#include "Tapefile.h"
#include <fstream>
using namespace std;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CTapefile 

DWORD WINAPI TapeBeep(void * pBeep)
{	
	volatile unsigned short *tone = (volatile unsigned short*) pBeep;
	if(tone)
		while(1)
		{
			Beep(*tone&0x8000? 1200:1500,20);
			*tone = *tone << 1;
		}
		return -1;
}

//static unsigned char beeper=0;
static volatile unsigned short beeper=0;


//##ModelId=43AD0C1D027F
CTapefile::CTapefile(CWnd* pParent /*=NULL*/)
	: CDialog(CTapefile::IDD, pParent)
	,m_chksum(0)
	,m_optr(0)
#pragma warning(push) 
#pragma warning( disable : 4355 )
	,m_list(this)
#pragma warning(pop) 

{
	m_beepThread = CreateThread(
		0,			    // pointer to security attributes
		0,              // initial thread stack size
		&TapeBeep,    // pointer to thread function
		(void*)&beeper,           // argument for new thread
		CREATE_SUSPENDED,  // creation flags
		0  // pointer to receive thread ID
		);
}


//##ModelId=43AD0C1D028A
void CTapefile::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTapefile)
	DDX_Control(pDX, IDC_IHEXLIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTapefile, CDialog)
	//{{AFX_MSG_MAP(CTapefile)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_TAPECLEAR, OnTapeclear)
	ON_BN_CLICKED(IDC_TAPELOAD, OnTapeload)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CTapefile 

//##ModelId=43AD0C1D02A8
void CTapefile::OnClose() 
{
	ShowWindow(SW_HIDE);
	EnableWindow(false);	
//	CDialog::OnClose();
}

//##ModelId=43AD0C1D0272
bool CTapefile::AddByte(unsigned char c)
{
	bool res = true;
	CString t;
	m_chksum += c;
	static int item = LB_ERR;
	beeper |=c;	
	switch( m_optr)
	{
	case 0: 
	//	m_list.ResetContent( );
		if(!IsWindowEnabled())
			AfxGetApp()->GetMainWnd()->PostMessage(WM_COMMAND ,IDM_TAPE);

		Sound(true);
		m_chksum=c;
		m_start = c * 0x100;
		item = LB_ERR;
		break;
	case 1:
		m_start += c;
		break;
	case 2:
		m_stop = c * 0x100;
		break;
	case 3:
		m_stop += c;
		break;
	default:
		{
			unsigned rest = m_stop - m_start - m_optr -3;
			if(!((m_optr-4) & 0xf)) 
			{
				t.Format("%2.2X%4.4X%2.2X", (rest < 0x10 ? rest:0x10), m_start + m_optr-4, rest < 16 ? 1:0 );
				item = m_list.AddString(":");
			}
			
			t += (unsigned char)(((c & 0xf0) > 0x90 ? ('A'-10):'0') + (c >> 4));
			t += (unsigned char)(((c & 0x0f) > 0x09 ? ('A'-10):'0') + (c & 0x0f));
		}
		break;
	}
	if(!t.IsEmpty())
	{
		if( item != LB_ERR)
		{
			CString f;
			m_list.GetText(item,f);
			f += t;
			m_list.DeleteString(item);
			item = m_list.AddString((LPCSTR)f);
		}
		else
		{
			m_list.AddString((LPCSTR)t);
		}
		Sleep(1);
	}
	m_optr++;
	if(m_optr > 3 && m_optr > (m_stop - m_start + 5))
	{
		Sound(false);
		m_optr = 0;
	}

	return res;
}

//##ModelId=43AD0C1D0278
int CTapefile::GetTapeBlock(int maxbyte, byte *data) const
{
	int res = 0;
	if(!IsWindowEnabled())
		AfxGetApp()->GetMainWnd()->PostMessage(WM_COMMAND ,IDM_TAPE);
	
	int i = m_list.GetSelCount();
	if( i )
	{
		CString str;
		int* items = new int[i];
		ASSERT(!items);
		m_list.GetSelItems(i, items);
		for( int e = 0; e < i; e++)
		{
			m_list.GetText(items[i], str);
			int cc = 0;
			int l = str.GetLength();
			//if( l >= 
		}

	}

	return res;

}

//##ModelId=43AD0C1D028D
unsigned int  CTapefile::CalcCheckSum(CString &to, int offset) const
{
	unsigned char cs = 0;

	int mx = to.GetLength();
	if(mx <= offset)
		return 0;

	for(int i = offset; i < mx && to[i] != ' '; i += 2)
	{
		unsigned char a = to[i]   - '0';
		unsigned char b = to[i+1] - '0';

		if( a > 9) 
			a -= ('A'-'9'-1);
		
		if( b > 9) 
			b -= ('A'-'9'-1);
		
		cs += ((a<<4) | b);
	}

	return (1 + ~cs) & 0xff;

}

//##ModelId=43AD0C1D0270
void CTapefile::Sound(bool mod)
{
	if(mod)
		ResumeThread(m_beepThread);
	else
		SuspendThread(m_beepThread);
}

//##ModelId=43AD0C1D026E
void CTapefile::Reset()
{
	Sound(false);
	m_optr = 0;
	m_list.ResetContent( );
}

//##ModelId=43AD0C1D02A0
void CTapefile::OnOK()
{ 
	CFileDialog fdlg(false , ".hex", "TK80TapeFile",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"Intel Hex (*.hex)|*.hex|All Files (*.*)|*.*||");
	CString file;
	CString tmp;

	if(fdlg.DoModal()== IDOK)
	{
		file = fdlg.GetPathName();
		//example for CFile::CFile
		TRY
		{
			CFile f( file, CFile::modeCreate | CFile::modeWrite );	
			for(int i = 0;i < m_list.GetCount();i++)
			{
				static char endl[]= { "\n"};
				m_list.GetText(i,tmp);
				if(tmp[0]==':')
				{
					unsigned  cs = CalcCheckSum(tmp,1);
					tmp += (unsigned char)(((cs & 0xf0) > 0x90 ? ('A'-10):'0') + (cs >> 4));
					tmp += (unsigned char)(((cs & 0x0f) > 0x09 ? ('A'-10):'0') + (cs & 0x0f));
				}
				f.Write((const void*) tmp,tmp.GetLength());
				f.Write(endl,strlen(endl));
				
			}
			f.Close();
		}
		CATCH( CFileException, e )
		{
		#ifdef _DEBUG
			afxDump << "File could not be opened " << e->m_cause << "\n";
		#endif
		}
		END_CATCH

	
	}

	OnClose();
};

//##ModelId=43AD0C1D02AA
void CTapefile::OnTapeclear() 
{
	Reset();	
}

//##ModelId=43AD0C1D02AC
void CTapefile::OnTapeload() 
{
	char buffer[512];

	CFileDialog fdlg(true , ".hex", "TK80TapeFile",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_FILEMUSTEXIST,
		"Intel Hex (*.hex)|*.hex|All Files (*.*)|*.*||");

	CString file;

	if(fdlg.DoModal()== IDOK)
	{
		file = fdlg.GetPathName();
		fstream f(file, ios::in);

		while(f.getline(buffer,sizeof(buffer)))
		{
			CString s = buffer;
			s.TrimLeft();
			s.TrimRight();
			int l = s.GetLength();;

			if( l>=9 && s[0] == ':')
			{
				int cs = CalcCheckSum(s,1);
				s.Delete(l-2,2);
				if ( cs )
					s += " Checksum ERROR";
				m_list.AddString((LPCSTR)s);
				if(cs)
					 
					switch(AfxMessageBox( "Chechsumerror in Intel Hex Data", MB_ICONSTOP | MB_TASKMODAL |MB_ABORTRETRYIGNORE,0))
				{
					case IDABORT: break;
					case IDRETRY: break;
					case IDIGNORE: break;
					default:;break;
				}

			}
		}
		f.close();
	}
}
