/*
 * Z80SIM  -  a	Z80-CPU	simulator
 *
 * Copyright (C) 1987-2006 by Udo Munk
 *
 * History:
 * 28-SEP-87 Development on TARGON/35 with AT&T Unix System V(3.1)
 * 11-JAN-89 Release 1.1
 * 08-FEB-89 Release 1.2
 * 13-MAR-89 Release 1.3
 * 09-FEB-90 Release 1.4 Ported to TARGON/31 M10/30
 * 20-DEC-90 Release 1.5 Ported to COHERENT 3.0
 * 10-JUN-92 Release 1.6 long casting problem solved with COHERENT 3.2
 *			 and some optimization
 * 25-JUN-92 Release 1.7 comments in english
 * 07-OCT-06 Release 1.8 modified to compile on modern POSIX OS's
 * 27-MAR-07 Release 2.0 Ported to CPP by J.Sievers <JSievers@nadhh.Hanse.de> 
 */

/*
 *	Like the function "cpu()" this one emulates 4 byte opcodes
 *	starting with 0xfd 0xcb
 */
#include "stdafx.h"
#include "zilog.h"




int z80::op_fdcb_handel(void)
{


	register int d;
	register int t;

	d = (char) (*this)[PC++];

	t = (this->*op_fdcb[(*this)[PC++]]) (d);	/* execute next opcode */

	return(t);
}


int z80::op_tb0iyd(int data)		/* BIT 0,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 1) ? (F &= ~(Z_FLAG | P_FLAG))
				 : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb1iyd(int data)		/* BIT 1,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 2) ? (F &= ~(Z_FLAG | P_FLAG))
				 : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb2iyd(int data)		/* BIT 2,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 4) ? (F &= ~(Z_FLAG | P_FLAG))
				 : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb3iyd(int data)		/* BIT 3,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 8) ? (F &= ~(Z_FLAG | P_FLAG))
				 : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb4iyd(int data)		/* BIT 4,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 16) ? (F &= ~(Z_FLAG | P_FLAG))
				  : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb5iyd(int data)		/* BIT 5,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 32) ? (F &= ~(Z_FLAG | P_FLAG))
				  : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb6iyd(int data)		/* BIT 6,(IY+d) */
{
	F &= ~(N_FLAG | S_FLAG);
	F |= H_FLAG;
	((*this)[IY + data] & 64) ? (F &= ~(Z_FLAG | P_FLAG))
				  : (F |= (Z_FLAG | P_FLAG));
	return(20);
}

int z80::op_tb7iyd(int data)		/* BIT 7,(IY+d) */
{
	F &= ~N_FLAG;
	F |= H_FLAG;
	if ((*this)[IY + data] & 128) {
		F &= ~(Z_FLAG | P_FLAG);
		F |= S_FLAG;
	} else {
		F |= (Z_FLAG | P_FLAG);
		F &= ~S_FLAG;
	}
	return(20);
}

int z80::op_rb0iyd(int data)		/* RES 0,(IY+d) */
{
	(*this)[IY + data] &= ~1;
	return(23);
}

int z80::op_rb1iyd(int data)		/* RES 1,(IY+d) */
{
	(*this)[IY + data] &= ~2;
	return(23);
}

int z80::op_rb2iyd(int data)		/* RES 2,(IY+d) */
{
	(*this)[IY + data] &= ~4;
	return(23);
}

int z80::op_rb3iyd(int data)		/* RES 3,(IY+d) */
{
	(*this)[IY + data] &= ~8;
	return(23);
}

int z80::op_rb4iyd(int data)		/* RES 4,(IY+d) */
{
	(*this)[IY + data] &= ~16;
	return(23);
}

int z80::op_rb5iyd(int data)		/* RES 5,(IY+d) */
{
	(*this)[IY + data] &= ~32;
	return(23);
}

int z80::op_rb6iyd(int data)		/* RES 6,(IY+d) */
{
	(*this)[IY + data] &= ~64;
	return(23);
}

int z80::op_rb7iyd(int data)		/* RES 7,(IY+d) */
{
	(*this)[IY + data] &= ~128;
	return(23);
}

int z80::op_sb0iyd(int data)		/* SET 0,(IY+d) */
{
	(*this)[IY + data] |= 1;
	return(23);
}

int z80::op_sb1iyd(int data)		/* SET 1,(IY+d) */
{
	(*this)[IY + data] |= 2;
	return(23);
}

int z80::op_sb2iyd(int data)		/* SET 2,(IY+d) */
{
	(*this)[IY + data] |= 4;
	return(23);
}

int z80::op_sb3iyd(int data)		/* SET 3,(IY+d) */
{
	(*this)[IY + data] |= 8;
	return(23);
}

int z80::op_sb4iyd(int data)		/* SET 4,(IY+d) */
{
	(*this)[IY + data] |= 16;
	return(23);
}

int z80::op_sb5iyd(int data)		/* SET 5,(IY+d) */
{
	(*this)[IY + data] |= 32;
	return(23);
}

int z80::op_sb6iyd(int data)		/* SET 6,(IY+d) */
{
	(*this)[IY + data] |= 64;
	return(23);
}

int z80::op_sb7iyd(int data)		/* SET 7,(IY+d) */
{
	(*this)[IY + data] |= 128;
	return(23);
}

int z80::op_rlciyd(int data)		/* RLC (IY+d) */
{
	register int i;
	register WORD p;

	p = IY + data;
	i = (*this)[p] & 128;
	(i) ? (F |= C_FLAG) : (F &= ~C_FLAG);
	F &= ~(H_FLAG |	N_FLAG);
	(*this)[p] <<= 1;
	if (i) (*this)[p] |= 1;
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}

int z80::op_rrciyd(int data)		/* RRC (IY+d) */
{
	register int i;
	register WORD p;

	p = IY + data;
	i = (*this)[p] & 1;
	(i) ? (F |= C_FLAG) : (F &= ~C_FLAG);
	F &= ~(H_FLAG |	N_FLAG);
	(*this)[p] >>= 1;
	if (i) (*this)[p] |= 128;
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}

int z80::op_rliyd(int data)		/* RL (IY+d) */
{
	register int old_c_flag;
	register WORD p;

	p = IY + data;
	old_c_flag = F & C_FLAG;
	((*this)[p] & 128) ? (F	|= C_FLAG) : (F	&= ~C_FLAG);
	(*this)[p] <<= 1;
	if (old_c_flag)	(*this)[p] |= 1;
	F &= ~(H_FLAG |	N_FLAG);
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}

int z80::op_rriyd(int data)		/* RR (IY+d) */
{
	register int old_c_flag;
	register WORD p;

	old_c_flag = F & C_FLAG;
	p = IY + data;
	((*this)[p] & 1) ? (F |= C_FLAG) : (F &= ~C_FLAG);
	(*this)[p] >>= 1;
	if (old_c_flag)	(*this)[p] |= 128;
	F &= ~(H_FLAG |	N_FLAG);
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}

int z80::op_slaiyd(int data)		/* SLA (IY+d) */
{
	register WORD p;

	p = IY + data;
	((*this)[p] & 128) ? (F	|= C_FLAG) : (F	&= ~C_FLAG);
	(*this)[p] <<= 1;
	F &= ~(H_FLAG |	N_FLAG);
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}

int z80::op_sraiyd(int data)		/* SRA (IY+d) */
{
	register int i;
	register WORD p;

	p = IY + data;
	i = (*this)[p] & 128;
	((*this)[p] & 1) ? (F |= C_FLAG) : (F &= ~C_FLAG);
	(*this)[p] >>= 1;
	(*this)[p] |= i;
	F &= ~(H_FLAG |	N_FLAG);
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}

int z80::op_srliyd(int data)		/* SRL (IY+d) */
{
	register WORD p;

	p = IY + data;
	((*this)[p] & 1) ? (F |= C_FLAG) : (F &= ~C_FLAG);
	(*this)[p] >>= 1;
	F &= ~(H_FLAG |	N_FLAG);
	((*this)[p]) ? (F &= ~Z_FLAG) :	(F |= Z_FLAG);
	((*this)[p] & 128) ? (F	|= S_FLAG) : (F	&= ~S_FLAG);
	(parrity[(*this)[p]]) ?	(F &= ~P_FLAG) : (F |= P_FLAG);
	return(23);
}
